/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores;

import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.service.UsuarioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.Base64;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import java.security.MessageDigest;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;

import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Textbox;

/**
 *
 * @author rodrigo
 */
@Controller("loginController")
@Scope("prototype")
public class LoginController extends MyGenericForwardComposer {

    @Autowired
    private UsuarioService usuarioService;
    private Usuario usuario;
    private Textbox txtUsuario;
    private Textbox txtSenha;
    private Logger log = Logger.getLogger(LoginController.class);

    public Textbox getTxtSenha() {
        return txtSenha;
    }

    public void setTxtSenha(Textbox txtSenha) {
        this.txtSenha = txtSenha;
    }

    public Textbox getTxtUsuario() {
        return txtUsuario;
    }

    public void setTxtUsuario(Textbox txtUsuario) {
        this.txtUsuario = txtUsuario;
    }

    public void onOK$txtSenha(Event ev) {
        onClick$btnAcessar(ev);
    }
    public void onClick$btnAcessar(Event ev) {
        String stUsuario = txtUsuario.getText();
        String senha = txtSenha.getText();

        try {
            if ((stUsuario != null) && (senha != null)) {
                MessageDigest md = MessageDigest.getInstance("MD5");
                byte[] pass = md.digest(senha.getBytes());
                senha = Base64.byteArrayToBase64(pass);

                usuario = usuarioService.buscarPeloNomeSenha(stUsuario, senha);

                if (usuario != null) {
                    UsuarioLogado.setUsuarioLogado(usuario);

                    desktop.getExecution().sendRedirect("/index.zul");

                    closeWindow();
                } else {
                    Messagebox.show(
                            Labels.getLabel("winLogin.lblloginIncorreto"),
                            Labels.getLabel("winLogin.title"),
                            Messagebox.OK, Messagebox.INFORMATION);
                }
            } else {
                Messagebox.show(
                        Labels.getLabel("winLogin.lblloginIncorreto"),
                        Labels.getLabel("winLogin.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
