/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.utilerias.render;

import com.rjconsultores.ventaboletos.entidad.ConvenioDet;
import java.math.BigDecimal;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

/**
 *
 * @author Administrador
 */
public class RenderConvenioDet implements ListitemRenderer {

    public void render(Listitem lstm, Object o) throws Exception {
        ConvenioDet convenioDet = (ConvenioDet) o;

        Listcell lc = new Listcell();

        BigDecimal porcentagem = convenioDet.getPorcdescuento();
        if (porcentagem != null) {
            lc = new Listcell(porcentagem.setScale(2).toString());
        } else {
            lc = new Listcell("");
        }
        lc.setParent(lstm);

        Long inicial = convenioDet.getNumfolioinicial();
        if (inicial != null) {
            lc = new Listcell(inicial.toString());
        } else {
            lc = new Listcell("");
        }
        lc.setParent(lstm);

        Long finaly = convenioDet.getNumfoliofinal();
        if (finaly != null) {
            lc = new Listcell(finaly.toString());
        } else {
            lc = new Listcell("");
        }
        lc.setParent(lstm);

        lstm.setAttribute("data", convenioDet);
    }
}
